Index: s390-tools-sles11/scripts/zfcpdbf
===================================================================
--- s390-tools-sles11.orig/scripts/zfcpdbf
+++ s390-tools-sles11/scripts/zfcpdbf
@@ -25,1068 +26,614 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #==============================================================================
 
-@PARAM_HELP				= qw(-h --help);
-@PARAM_DEVICE				= qw(-d --device);
-@PARAM_PATH				= qw(-p --path);
-@PARAM_DATES				= qw(-D --dates);
-@PARAM_SINGLELINE			= qw(-s --singleline);
-@PARAM_COLOR				= qw(-c --color);
-$PARAM_DEBUG_CT				= 'ct';
-$PARAM_DEBUG_ELS			= 'els';
-$PARAM_DEBUG_BAD			= 'bad';
-@PARAM_VERBOSE				= qw(-V --verbose);
-@PARAM_VERSION				= qw(-v --version);
-$OFF					= 'off';
-$ON					= 'on';
-$TRACE_HBA				= 'hba';
-$TRACE_SAN				= 'san';
-$TRACE_SCSI				= 'scsi';
-
-$DBF_PATH_PROCFS			= '/proc/s390dbf';
-$DBF_PATH_DEBUGFS			= '/sys/kernel/debug/s390dbf';
-$DBF_PREFIX				= 'zfcp_';
-$DBF_FILE				= 'structured';
-
-$MIN_KERNEL_VERSION			= "2.4.21";
-
-$TAG_SIZE				= 4;
-
-$DEVICE					= 'device';
-$TIMESTAMP				= 'timestamp';
-$TAG					= 'tag';
-$SUBTAG					= 'tag2';
-$FSF_REQ_ID				= 'fsf_reqid';
-$FSF_REQ_SEQNO				= 'fsf_seqno';
-$ABORT_FSF_REQ_ID			= 'abort_fsf_reqid';
-$ABORT_FSF_REQ_SEQNO			= 'abort_fsf_seqno';
-$NEW_FSF_REQ_ID				= 'new_fsf_reqid';
-$NEW_FSF_REQ_SEQNO			= 'new_fsf_seqno';
-$FSF_COMMAND				= 'fsf_command';
-$PROT_STATUS				= 'fsf_prot_status';
-$PROT_STATUS_QUAL			= 'fsf_prot_status_qual';
-$FSF_STATUS				= 'fsf_status';
-$FSF_STATUS_QUAL			= 'fsf_status_qual';
-$FSF_REQUEST_STATUS			= 'fsf_req_status';
-$FIRST_SBAL				= 'sbal_first';
-$CURRENT_SBAL				= 'sbal_curr';
-$LAST_SBAL				= 'sbal_last';
-$LS_CODE				= 'ls_code';
-$S_ID					= 's_id';
-$D_ID					= 'd_id';
-$WWPN					= 'wwpn';
-$FCP_LUN				= 'fcp_lun';
-$PORT_HANDLE				= 'port_handle';
-$LUN_HANDLE				= 'lun_handle';
-$SCSI_COMMAND				= 'scsi_cmnd';
-$SCSI_SERIAL				= 'scsi_serial';
-$SCSI_ID				= 'scsi_id';
-$SCSI_LUN				= 'scsi_lun';
-$SCSI_OPCODE				= 'scsi_opcode';
-$SCSI_RETRIES				= 'scsi_retries';
-$SCSI_ALLOWED				= 'scsi_allowed';
-$FCP_RSP_VALIDITY			= 'fcp_rsp_validity';
-$FCP_RSP_SCSI_STATUS			= 'fcp_rsp_scsi_status';
-$FCP_RSP_RESIDUAL			= 'fcp_rsp_resid';
-$FCP_RSP_CODE				= 'fcp_rsp_code';
-$FCP_SNS_INFO_LEN			= 'fcp_sns_info_len';
-$FCP_SNS_INFO				= 'fcp_sns_info';
-$FAILED					= 'failed';
-$STATUS_TYPE				= 'status_type';
-$STATUS_SUBTYPE				= 'status_subtype';
-$QUEUE_DESIGNATOR			= 'queue_designator';
-$PAYLOAD				= 'payload';
-$UNKNOWN				= 'unknown';
-
-$TAG_CT_REQUEST				= 'octc';
-$TAG_CT_RESPONSE			= 'rctc';
-$TAG_ELS_REQUEST			= 'oels';
-$TAG_ELS_RESPONSE			= 'rels';
-$TAG_INCOMING_ELS			= 'iels';
-$TAG_UNSOLICITED_STATUS			= 'stat';
-$TAG_STATUS_READ			= 'read';
-$TAG_DISMISSED				= 'dism';
-$TAG_FAILED				= 'fail';
-$TAG_QDIO				= 'qdio';
-$TAG_FSF_REQ_RESPONSE			= 'resp';
-$TAG_PROT_STATUS_ERROR			= 'perr';
-$TAG_FSF_STATUS_ERROR			= 'ferr';
-$TAG_STATUS_QUAL_AVAILABLE		= 'qual';
-$TAG_FSF_REQUEST_TRACE			= 'norm';
-$TAG_SCSI_COMPLETION			= 'rslt';
-$TAG_SCSI_ABORT				= 'abrt';
-$TAG_SCSI_TARGET_RESET			= 'trst';
-$TAG_SCSI_RESET				= 'lrst';
-
-my(%fsf_req_status) = (
-	0x00000000,			'',
-	0x00000001,			'',
-	0x00000002,			'task management',
-	0x00000004,			'completed',
-	0x00000008,			'error',
-	0x00000010,			'cleanup',
-	0x00000020,			'aborting',
-	0x00000040,			'abort succeeded',
-	0x00000080,			'abort not needed',
-	0x00000100,			'aborted',
-	0x00000200,			'tm func failed',
-	0x00000400,			'tm func not supported',
-	0x00000800,			'retry',
-	0x00001000,			'dismissed',
-);
-
-$QTCB_SEND_FCP_COMMAND			= 0x00000001;
-$QTCB_ABORT_FCP_COMMAND			= 0x00000002;
-$QTCB_OPEN_PORT				= 0x00000005;
-$QTCB_OPEN_LUN				= 0x00000006;
-$QTCB_CLOSE_LUN				= 0x00000007;
-$QTCB_CLOSE_PORT			= 0x00000008;
-$QTCB_CLOSE_PHYSICAL_PORT		= 0x00000009;
-$QTCB_SEND_ELS				= 0x0000000B;
-$QTCB_SEND_GENERIC			= 0x0000000C;
-$QTCB_EXCHANGE_CONFIG_DATA		= 0x0000000D;
-$QTCB_EXCHANGE_PORT_DATA		= 0x0000000E;
-$QTCB_DOWNLOAD_CONTROL_FILE		= 0x00000012;
-$QTCB_UPLOAD_CONTROL_FILE		= 0x00000013;
+use strict;
+use warnings;
+use Getopt::Long;
+use File::Basename;
 
 my(%fsf_command) = (
-	$QTCB_SEND_FCP_COMMAND,		'send FCP command',
-	$QTCB_ABORT_FCP_COMMAND,	'abort FCP command',
-	$QTCB_OPEN_PORT,		'open port',
-	$QTCB_OPEN_LUN,			'open unit',
-	$QTCB_CLOSE_LUN,		'close unit',
-	$QTCB_CLOSE_PORT,		'close port',
-	$QTCB_CLOSE_PHYSICAL_PORT,	'close port physical',
-	$QTCB_SEND_ELS,			'send ELS',
-	$QTCB_SEND_GENERIC,		'send generic',
-	$QTCB_EXCHANGE_CONFIG_DATA,	'exchange config data',
-	$QTCB_EXCHANGE_PORT_DATA,	'exchange port data',
-	$QTCB_DOWNLOAD_CONTROL_FILE,	'download control file',
-	$QTCB_UPLOAD_CONTROL_FILE,	'upload control file'
+	'0x00000001' =>	'send FCP command',
+	'0x00000002' =>	'abort FCP command',
+	'0x00000005' =>	'open port',
+	'0x00000006' =>	'open unit',
+	'0x00000007' =>	'close unit',
+	'0x00000008' =>	'close port',
+	'0x00000009' =>	'close port physical',
+	'0x0000000b' =>	'send ELS',
+	'0x0000000c' =>	'send generic',
+	'0x0000000d' =>	'exchange config data',
+	'0x0000000e' =>	'exchange port data',
+	'0x00000012' =>	'download control file',
+	'0x00000013' =>	'upload control file'
 );
 
-$FSF_PROT_GOOD				= 0x00000001;
-$FSF_PROT_QTCB_VERSION_ERROR		= 0x00000010;
-$FSF_PROT_SEQ_NUMB_ERROR		= 0x00000020;
-$FSF_PROT_UNSUPP_QTCB_TYPE		= 0x00000040;
-$FSF_PROT_HOST_CONNECTION_INITIALIZING	= 0x00000080;
-$FSF_PROT_FSF_STATUS_PRESENTED		= 0x00000100;
-$FSF_PROT_DUPLICATE_REQUEST_ID		= 0x00000200;
-$FSF_PROT_LINK_DOWN			= 0x00000400;
-$FSF_PROT_REEST_QUEUE			= 0x00000800;
-$FSF_PROT_ERROR_STATE			= 0x01000000;
-
 my(%protocol_status) = (
-	$FSF_PROT_GOOD,			'good',
-	$FSF_PROT_QTCB_VERSION_ERROR,	'QTCB version error',
-	$FSF_PROT_SEQ_NUMB_ERROR,	'sequence number error',
-	$FSF_PROT_UNSUPP_QTCB_TYPE,	'unsupported QTCB type',
-	$FSF_PROT_HOST_CONNECTION_INITIALIZING, 'host connection initializing',
-	$FSF_PROT_FSF_STATUS_PRESENTED,	'FSF status presented',
-	$FSF_PROT_DUPLICATE_REQUEST_ID,	'duplicate request ID',
-	$FSF_PROT_LINK_DOWN,		'link down',
-	$FSF_PROT_REEST_QUEUE,		'reestablished queue',
-	$FSF_PROT_ERROR_STATE,		'error state'
+	'0x00000001' =>	'good',
+	'0x00000010' =>	'QTCB version error',
+	'0x00000020' =>	'sequence number error',
+	'0x00000040' =>	'unsupported QTCB type',
+	'0x00000080' => 'host connection initializing',
+	'0x00000100' =>	'FSF status presented',
+	'0x00000200' =>	'duplicate request ID',
+	'0x00000400' =>	'link down',
+	'0x00000800' =>	'reestablished queue',
+	'0x01000000' =>	'error state'
 );
 
-$FSF_GOOD				= 0x00000000;
-$FSF_PORT_ALREADY_OPEN			= 0x00000001;
-$FSF_LUN_ALREADY_OPEN			= 0x00000002;
-$FSF_PORT_HANDLE_NOT_VALID		= 0x00000003;
-$FSF_LUN_HANDLE_NOT_VALID		= 0x00000004;
-$FSF_HANDLE_MISMATCH			= 0x00000005;
-$FSF_SERVICE_CLASS_NOT_SUPPORTED	= 0x00000006;
-$FSF_FCPLUN_NOT_VALID			= 0x00000009;
-$FSF_ACCESS_DENIED			= 0x00000010;
-$FSF_ACCESS_TYPE_NOT_VALID		= 0x00000011;
-$FSF_LUN_SHARING_VIOLATION		= 0x00000012;
-$FSF_FCP_COMMAND_DOES_NOT_EXIST		= 0x00000022;
-$FSF_DIRECTION_INDICATOR_NOT_VALID	= 0x00000030;
-$FSF_CMND_LENGTH_NOT_VALID		= 0x00000033;
-$FSF_MAXIMUM_NUMBER_OF_PORTS_EXCEEDED	= 0x00000040;
-$FSF_MAXIMUM_NUMBER_OF_LUNS_EXCEEDED	= 0x00000041;
-$FSF_ELS_COMMAND_REJECTED		= 0x00000050;
-$FSF_GENERIC_COMMAND_REJECTED		= 0x00000051;
-$FSF_OPERATION_PARTIALLY_SUCCESSFUL	= 0x00000052;
-$FSF_AUTHORIZATION_FAILURE		= 0x00000053;
-$FSF_ACT_ERROR_DETECTED			= 0x00000054;
-$FSF_CONTROL_FILE_UPDATE_ERROR		= 0x00000055;
-$FSF_CONTROL_FILE_TOO_LARGE		= 0x00000056;
-$FSF_ACCESS_CONFLICT_DETECTED		= 0x00000057;
-$FSF_CONFLICTS_OVERRULED		= 0x00000058;
-$FSF_PORT_BOXED				= 0x00000059;
-$FSF_LUN_BOXED				= 0x0000005A;
-$FSF_EXCHANGE_CONFIG_DATA_INCOMPLETE	= 0x0000005B;
-$FSF_PAYLOAD_SIZE_MISMATCH		= 0x00000060;
-$FSF_REQUEST_SIZE_TOO_LARGE		= 0x00000061;
-$FSF_RESPONSE_SIZE_TOO_LARGE		= 0x00000062;
-$FSF_SBAL_MISMATCH			= 0x00000063;
-$FSF_OPEN_PORT_WITHOUT_PRLI		= 0x00000064;
-$FSF_ADAPTER_STATUS_AVAILABLE		= 0x000000AD;
-$FSF_FCP_RSP_AVAILABLE			= 0x000000AF;
-$FSF_UNKNOWN_COMMAND			= 0x000000E2;
-$FSF_UNKNOWN_OP_SUBTYPE			= 0x000000E3;
-$FSF_INVALID_COMMAND_OPTION		= 0x000000E5;
-
 my(%fsf_status) = (
-	$FSF_GOOD,
-			'good',
-	$FSF_PORT_ALREADY_OPEN,
-			'port already open',
-	$FSF_LUN_ALREADY_OPEN,
-			'unit already open',
-	$FSF_PORT_HANDLE_NOT_VALID,
-			'port handle not valid',
-	$FSF_LUN_HANDLE_NOT_VALID,
-			'unit handle not valid',
-	$FSF_HANDLE_MISMATCH,
-			'handle mismatch',
-	$FSF_SERVICE_CLASS_NOT_SUPPORTED,
-			'service class not supported',
-	$FSF_FCPLUN_NOT_VALID,
-			'FCP LUN not valid',
-	$FSF_ACCESS_DENIED,
-			'access denied',
-	$FSF_ACCESS_TYPE_NOT_VALID,
-			'access type not valid',
-	$FSF_LUN_SHARING_VIOLATION,
-			'LUN sharing violation',
-	$FSF_FCP_COMMAND_DOES_NOT_EXIST,
-			'command does not exist',
-	$FSF_DIRECTION_INDICATOR_NOT_VALID,
-			'direction indicator not valid',
-	$FSF_CMND_LENGTH_NOT_VALID,
-			'command length not valid',
-	$FSF_MAXIMUM_NUMBER_OF_PORTS_EXCEEDED,
-			'max number of ports exceeded',
-	$FSF_MAXIMUM_NUMBER_OF_LUNS_EXCEEDED,
-			'max number of units exceeded',
-	$FSF_ELS_COMMAND_REJECTED,
-			'ELS rejected',
-	$FSF_GENERIC_COMMAND_REJECTED,
-			'generic command rejected',
-	$FSF_OPERATION_PARTIALLY_SUCCESSFUL,
-			'partially successful',
-	$FSF_AUTHORIZATION_FAILURE,
-			'authorization failure',
-	$FSF_ACT_ERROR_DETECTED,
-			'ACT error detected',
-	$FSF_CONTROL_FILE_UPDATE_ERROR,
-			'control file update error',
-	$FSF_CONTROL_FILE_TOO_LARGE,
-			'control file too large',
-	$FSF_ACCESS_CONFLICT_DETECTED,
-			'access conflict detected',
-	$FSF_CONFLICTS_OVERRULED,
-			'conflicts overruled',
-	$FSF_PORT_BOXED,
-			'port boxed',
-	$FSF_LUN_BOXED,
-			'unit boxed',
-	$FSF_EXCHANGE_CONFIG_DATA_INCOMPLETE,
-			'exchange config/port data incomplete',
-	$FSF_PAYLOAD_SIZE_MISMATCH,
-			'payload size mismatch',
-	$FSF_REQUEST_SIZE_TOO_LARGE,
-			'request too large',
-	$FSF_RESPONSE_SIZE_TOO_LARGE,
-			'response too large',
-	$FSF_SBAL_MISMATCH,
-			'SBAL mismatch',
-	$FSF_OPEN_PORT_WITHOUT_PRLI,
-			'open port without PRLI',
-	$FSF_ADAPTER_STATUS_AVAILABLE,
-			'adapter status available',
-	$FSF_FCP_RSP_AVAILABLE,
-			'FCP RSP available',
-	$FSF_UNKNOWN_COMMAND,
-			'unknown command',
-	$FSF_UNKNOWN_OP_SUBTYPE,
-			'unknown op subtype',
-	$FSF_INVALID_COMMAND_OPTION,
-			'invalid command option'
+	'0x00000000' =>	'good',
+	'0x00000001' =>	'port already open',
+	'0x00000002' => 'unit already open',
+	'0x00000003' => 'port handle not valid',
+	'0x00000004' => 'unit handle not valid',
+	'0x00000005' =>	'handle mismatch',
+	'0x00000006' => 'service class not supported',
+	'0x00000009' => 'FCP LUN not valid',
+	'0x00000010' => 'access denied',
+	'0x00000011' => 'access type not valid',
+	'0x00000012' =>	'LUN sharing violation',
+	'0x00000022' =>	'command does not exist',
+	'0x00000030' => 'direction indicator not valid',
+	'0x00000033' => 'command length not valid',
+	'0x00000040' =>	'max number of ports exceeded',
+	'0x00000041' => 'max number of units exceeded',
+	'0x00000050' => 'ELS rejected',
+	'0x00000051' =>	'generic command rejected',
+	'0x00000052' => 'partially successful',
+	'0x00000053' => 'authorization failure',
+	'0x00000054' =>	'ACT error detected',
+	'0x00000055' => 'control file update error',
+	'0x00000056' => 'control file too large',
+	'0x00000057' => 'access conflict detected',
+	'0x00000058' => 'conflicts overruled',
+	'0x00000059' => 'port boxed',
+	'0x0000005a' => 'unit boxed',
+	'0x0000005b' => 'exchange config/port data incomplete',
+	'0x00000060' =>	'payload size mismatch',
+	'0x00000061' =>	'request too large',
+	'0x00000062' => 'response too large',
+	'0x00000063' => 'SBAL mismatch',
+	'0x00000064' => 'open port without PRLI',
+	'0x000000ad' => 'adapter status available',
+	'0x000000af' => 'FCP RSP available',
+	'0x000000e2' => 'unknown command',
+	'0x000000e3' => 'unknown op subtype',
+	'0x000000e5' =>	'invalid command option'
 );
 
 my(%unsolicited_status) = (
-	0x00000001,			'port closed',
-	0x00000002,			'incoming ELS',
-	0x00000003,			'sense data available',
-	0x00000004,			'bit error threshold',
-	0x00000005,			'link down',
-	0x00000006,			'link up',
-	0x00000009,			'notification lost',
-	0x0000000A,			'ACT updated',
-	0x0000000B,			'ACT hardened'
+	'0x00000001' =>	'port closed',
+	'0x00000002' =>	'incoming ELS',
+	'0x00000003' => 'sense data available',
+	'0x00000004' =>	'bit error threshold',
+	'0x00000005' =>	'link down',
+	'0x00000006' =>	'link up',
+	'0x00000009' =>	'notification lost',
+	'0x0000000a' =>	'ACT updated',
+	'0x0000000b' =>	'ACT hardened'
 );
 
-my(%els) = (
-	0x01,				'RJT',
-	0x02,				'ACC',
-	0x03,				'PLOGI',
-	0x05,				'LOGO',
-	0x0E,				'RTV',
-	0x0F,				'RLS',
-	0x50,				'PDISC',
-	0x52,				'ADISC',
-	0x61,				'RSCN',
-	0x78,				'RNID',
-	0x7A,				'RLIR'
-);
-
-$COLOR_DEFAULT				= "\033[m\017";
-$COLOR_GREEN				= "\033[32m";
-$COLOR_RED				= "\033[31m";
-
-my(%color);
-
-$NOTABOOL	= -1;
-$FALSE		= 0;
-$TRUE		= 1;
-
-my($path, $device, $trace) =
-	('', '*', '');
-my($dates, $single_line, $color, $verbose) =
-	($TRUE, $FALSE, $FALSE, $FALSE);
-my($debug_ct, $debug_els, $debug_bad, $debug_unsol) =
-	($TRUE, $FALSE, $TRUE, $TRUE);
-my($from_year, $from_mon, $from_mday, $from_hour, $from_min, $from_sec) =
-	(-1, -1, -1, -1, -1, -1);
-my($to_year, $to_mon, $to_mday, $to_hour, $to_min, $to_sec) =
-	(-1, -1, -1, -1, -1, -1);
-
-my(@dbf_files, $single_device, %event_list, @filter);
-
-sub fetch_parameters
-{
-	my($linux_release) = &kernel_version(`uname --release`);
-
-	if ($linux_release < &kernel_version($MIN_KERNEL_VERSION)) {
-		printf "zfcpdbf works only with kernel version %s or higher\n",
-				$MIN_KERNEL_VERSION;
-		exit;
-	}
+#COMMAND LINE OPTIONS
 
-	for (my $index = 0; $index <= $#ARGV; $index++) {
-		my($parameter, $value);
-		if ((index $ARGV[$index], '=') != -1) {
-			($parameter, $value) = split /\=/, $ARGV[$index];
-		} elsif ($index < $#ARGV) {
-			($parameter, $value) = ($ARGV[$index], $ARGV[$index + 1]);
-		} else {
-			($parameter, $value) = ($ARGV[$index], $TRUE);
-		}
+my $OPT_HBA	= 0;
+my $OPT_SAN	= 0;
+my $OPT_SCSI	= 0;
+my $OPT_REC	= 0;
+my $OPT_DEVICE	= "";
+my $OPT_PATH	= "";
+my $OPT_VERBOSE	= 0;
+my $OPT_HELP	= 0;
+my $OPT_VERSION	= 0;
+my $OPT_DATE 	= "on";
+my $OPT_SINGLELINE =0;
 
-		my($switch);
-		if ((($value cmp $OFF) == 0) || (($value cmp '0') == 0)) {
-			$switch = $FALSE;
-		} elsif ((($value cmp $ON) == 0) || (($value cmp '1') == 0)) {
-			$switch = $TRUE;
-		} else {
-			$switch = $NOTABOOL;
-		}
+#string for the singleline option
+my $endl	="\n\t";
 
-		if (($parameter cmp $PARAM_HELP[0]) == 0 ||
-		         ($parameter cmp $PARAM_HELP[1]) == 0) {
-			&print_help();
-		} elsif (($parameter cmp $PARAM_VERSION[0]) == 0 ||
-		         ($parameter cmp $PARAM_VERSION[1]) == 0) {
-			&print_version();
-		} elsif (($parameter cmp $PARAM_DEVICE[0]) == 0 ||
-		         ($parameter cmp $PARAM_DEVICE[1]) == 0) {
-			$device = $value;
-		} elsif (($parameter cmp $PARAM_PATH[0]) == 0 ||
-		         ($parameter cmp $PARAM_PATH[1]) == 0) {
-			$path = $value;
-		} elsif (($parameter cmp $TRACE_HBA) == 0 ||
-		         ($parameter cmp $TRACE_SAN) == 0 ||
-		         ($parameter cmp $TRACE_SCSI) == 0) {
-			&print_help() unless length($trace) == 0;
-			$trace = $parameter;
-		} elsif (($parameter cmp $PARAM_DATES[0]) == 0 ||
-		         ($parameter cmp $PARAM_DATES[1]) == 0) {
-			&print_help() if $switch == $NOTABOOL;
-			$dates = $switch;
-		} elsif (($parameter cmp $PARAM_SINGLELINE[0]) == 0 ||
-		         ($parameter cmp $PARAM_SINGLELINE[1]) == 0) {
-			$single_line = $TRUE;
-		} elsif (($parameter cmp $PARAM_COLOR[0]) == 0 ||
-		         ($parameter cmp $PARAM_COLOR[1]) == 0) {
-			$color = $TRUE;
-		} elsif (($parameter cmp $PARAM_DEBUG_CT) == 0) {
-			&print_help() if $switch == $NOTABOOL;
-			$debug_ct = $switch;
-		} elsif (($parameter cmp $PARAM_DEBUG_ELS) == 0) {
-			&print_help() if $switch == $NOTABOOL;
-			$debug_els = $switch;
-		} elsif (($parameter cmp $PARAM_DEBUG_BAD) == 0) {
-			&print_help() if $switch == $NOTABOOL;
-			$debug_bad = $switch;
-		} elsif (($parameter cmp $PARAM_VERBOSE[0]) == 0 ||
-		         ($parameter cmp $PARAM_VERBOSE[1]) == 0) {
-			$verbose = $TRUE;
-		} else {
-			push @filter, $parameter . '=' . $value;
-		}
-	}
+#PARSE COMMAND LINE OPTIONS
+Getopt::Long::Configure('bundling');
 
-	$trace = $TRACE_SAN if length($trace) == 0;
+GetOptions(
+	'd|device=s'	=> \$OPT_DEVICE,
+	'p|path=s'	=> \$OPT_PATH,
+	'V|verbose'	=> \$OPT_VERBOSE,
+	'h|help'	=> \$OPT_HELP,
+	'v|version'	=> \$OPT_VERSION,
+	'D|date=s'	=> \$OPT_DATE,
+	's|singleline'	=> \$OPT_SINGLELINE
+) or print_usage();
 
-	if (length($path) > 0) {
-		while (((substr $path, length($path) - 1, 1) cmp '/') == 0) {
-			substr ($path, length($path) - 1, 1) = '';
-		}
-	} else {
-		if ( -d $DBF_PATH_PROCFS) {
-			$path = $DBF_PATH_PROCFS;
-		} elsif ( -d $DBF_PATH_DEBUGFS) {
-			$path = $DBF_PATH_DEBUGFS;
-		}
+foreach(@ARGV) { 
+	if($_ eq 'hba') {
+		$OPT_HBA = 1;
 	}
-
-	if (($device cmp '*') != 0) {
-		while (length($device) < 4) {
-			$device = '0' . $device;
-		}
+	elsif( $_ eq 'scsi') {
+		$OPT_SCSI = 1;
 	}
-
-	if ( ! -d glob sprintf "%s/%s%s_*", $path, $DBF_PREFIX, $device) {
-		if (($device cmp '*') != 0) {
-			printf "No DBF files found for FCP adapter %s\n",
-					$device;
-		} else {
-			print "No DBF files found\n";
-		}
-		exit;
+	elsif($_ eq 'rec') {
+		$OPT_REC = 1;
 	}
-
-#	push @dbf_files, glob(sprintf "%s/%s%s_erp/%s",
-#			$path, $DBF_PREFIX, $device, $DBF_FILE);
-	push @dbf_files, glob(sprintf "%s/%s%s_hba/%s",
-			$path, $DBF_PREFIX, $device, $DBF_FILE);
-	push @dbf_files, glob(sprintf "%s/%s%s_san/%s",
-			$path, $DBF_PREFIX, $device, $DBF_FILE);
-	push @dbf_files, glob(sprintf "%s/%s%s_scsi/%s",
-			$path, $DBF_PREFIX, $device, $DBF_FILE);
-
-	if ($#dbf_files < 0) {
-		print "No DBF files found\n";
-		exit;
+	elsif($_ eq 'san') {
+		$OPT_SAN = 1;
 	}
+};
 
-	$single_device = $#dbf_files == 2;
+#MAIN PROGRAM
 
-	$from_year += 1900 if ($from_year != -1) && ($from_year < 100);
-	$to_year   += 1900 if ($to_year   != -1) && ($to_year   < 100);
+if($OPT_HELP) {
+	print_usage();
+}
+ 
+if($OPT_VERSION) {
+	print_version();
 }
 
-sub print_help
-{
-	printf "\n" .
-"Usage: zfcpdbf [COMMAND] [OPTIONS]\n" .
-"\n" .
-"Sort debug data of all active or specified FCP adapter(s).\n" .
-"  -h, --help                display this help and exit\n" .
-"  -v, --version             display version information and exit\n" .
-"commands:\n" .
-"  hba                       trace all FSF requests\n" .
-"  san                       trace SAN activity (default)\n" .
-"  scsi                      trace SCSI- and corresponding FCP-commands\n" .
-"options:\n" .
-"  -d, --device=<device>     FCP adapter device number\n" .
-"  -p, --path=<path>         specifiy path to DBF files\n" .
-"  -D, --dates={off|on}      show date as well as time (default: %s)\n" .
-#"  --ct={off|on}             trace send CT commands (default: %s)\n" .
-#"  --els={off|on}            trace ELS commands and incoming ELS (default: %s)\n" .
-#"  --baf={off|on}            trace all FSF commands with bad response (default: %s)\n" .
-"  -s, --singleline          output in one line per event\n" .
-"  -c, --color               colored output\n" .
-"  -V, --verbose             verbose output\n" .
-$dates; # $debug_ct, $debug_unsol, $debug_bad;
-	exit;
+if($OPT_SINGLELINE) {
+	$endl = "; ";
 }
 
-sub print_version
-{
-	my($s390tools_version) = '%S390_TOOLS_VERSION%';
-	printf "zfcpdbf: version %s.\n", $s390tools_version;
-	printf "Copyright IBM Corp. 2005, 2006.\n";
+if($OPT_DATE ne "" && $OPT_DATE ne "on" and  $OPT_DATE ne "off") {
+	print "Date has to be set 'on'(default) or 'off'" . 
+		" and not '$OPT_DATE'.\n";
 	exit;
 }
-
-sub init
-{
-	&fetch_parameters();
-
-	if ($color) {
-		$color{'default'}   = $COLOR_DEFAULT;
-		$color{'timestamp'} = $COLOR_GREEN;
-		$color{'error'}     = $COLOR_RED;
-	}
+	 
+if($OPT_DEVICE eq "") {
+	$OPT_DEVICE = "*";
 }
-
-sub load
-{
-	foreach my $dbf_file (@dbf_files) {
-		&die("Cannot open a DBF file $dbf_file!\n")
-			unless open DBF, $dbf_file;
-		while (<DBF>) {
-			chomp;
-			my($label, $timestamp) = split;
-			my($tm, $ms) = split /\:/, $timestamp;
-			my($sec, $min, $hour, $mday, $mon, $year, $wday, $yday) =
-				gmtime($tm);
-			$year += 1900;
-
-			next if (($from_year != -1) && ($from_year > $year)) ||
-			        (($to_year   != -1) && ($to_year   < $year));
-			next if (($from_mon  != -1) && ($from_mon  > $mon )) ||
-			        (($to_mon    != -1) && ($to_mon    < $mon ));
-			next if (($from_mday != -1) && ($from_mday > $mday)) ||
-			        (($to_mday   != -1) && ($to_mday   < $mday));
-			next if (($from_hour != -1) && ($from_hour > $hour)) ||
-			        (($to_hour   != -1) && ($to_hour   < $hour));
-			next if (($from_min  != -1) && ($from_min  > $min )) ||
-			        (($to_min    != -1) && ($to_min    < $min ));
-			next if (($from_sec  != -1) && ($from_sec  > $sec )) ||
-			        (($to_sec    != -1) && ($to_sec    < $sec ));
-
-			my($event);
-			if (!$single_device) {
-				my($offset, $length);
-				$offset  = length($path) + 1;
-				$offset += index(substr($dbf_file, $offset), '_');
-				$offset++;
-				$length  = index(substr($dbf_file, $offset), '_');
-				$event = $DEVICE . '=' . substr
-						$dbf_file, $offset, $length;
-			}
-
-			my($tag_label) = $TAG;
-			while (<DBF>) {
-				chomp;
-				my($string) = $_;
-				last if length($string) == 0;
-
-				my($label, $value);
-				my($pos) = 0;
-				$pos++ while (((substr $string, $pos, 1) cmp ' ') == 0);
-				$label = substr($string, $pos, index(substr($string, $pos), ' '));
-				$pos += length $label;
-				$pos++ while (((substr $string, $pos, 1) cmp ' ') == 0);
-				$value = substr($string, $pos);
-				if (($label cmp $TAG) == 0) {
-					$label = $tag_label;
-					$tag_label = $SUBTAG;
-				}
-				$event .= ';' unless length $event == 0;
-				$event .= $label . '=' . $value;
-			}
-
-			$event_list{$timestamp} = $event;
-		}
+#Check if the adapter is set correct
+else {
+	while(length($OPT_DEVICE) < 4) {
+		$OPT_DEVICE = '0' . $OPT_DEVICE;
 	}
-}
 
-sub main
-{
-	if (($trace cmp $TRACE_HBA) == 0) {
-		&trace_hba();
-	} elsif (($trace cmp $TRACE_SAN) == 0) {
-		&trace_san();
-	} elsif (($trace cmp $TRACE_SCSI) == 0) {
-		&trace_scsi();
+	if(length($OPT_DEVICE) == 4) {
+		$OPT_DEVICE = "0.0." . $OPT_DEVICE;
 	}
-}
 
-sub done
-{
+	if(length($OPT_DEVICE) != 8 or $OPT_DEVICE !~ /^0\.0\./) {
+		printf "'$OPT_DEVICE' does not look like a FCP adapter.\n";
+		exit;
+	}
 }
 
-sub die
-{
-	printf "%s%s%s", $color{'error'}, @_, $color{'default'};
-	exit -1;
+if($OPT_PATH eq "") {
+	$OPT_PATH = '/sys/kernel/debug/s390dbf';
 }
 
-sub print_label
-{
-	my($timestamp) = @_;
+#Check if path exist
+if(! -d $OPT_PATH) {
+	printf $OPT_PATH . " does not exist. Is debugfs mounted?\n";
+	exit;
+} 
 
-	if ($single_device) {
-		return sprintf "%s%s%s",
-				$color{'timestamp'},
-				&print_time($timestamp),
-				$color{'default'};
-	} else {
-		return sprintf "%s%s %s%s",
-				$color{'timestamp'},
-				&grep($event_list{$timestamp}, $DEVICE),
-				&print_time($timestamp),
-				$color{'default'};
+my @paths  = glob($OPT_PATH . "/zfcp_" . $OPT_DEVICE . "_*"); 
+unless(@paths) {
+	if($OPT_DEVICE ne "*") {
+		printf "No DBF files found for FCP adapter %s.\n",
+			$OPT_DEVICE;
+	} 
+	else {
+		printf "No DBF files found at %s.\n",$OPT_PATH;
 	}
+	exit;
+}	 
+
+if($OPT_HBA) {
+	my @hba_paths = @{filter_paths("hba",@paths)};
+	trace_hba(@hba_paths);
+}
+elsif($OPT_SCSI) {
+	my @scsi_paths = @{filter_paths("scsi",@paths)};
+	trace_scsi(@scsi_paths);
+}
+elsif($OPT_REC) {
+	my @rec_paths = @{filter_paths("rec",@paths)};
+	trace_rec(@rec_paths);
+}
+else {
+	my @san_paths = @{filter_paths("san",@paths)};
+	trace_san(@san_paths);
 }
 
-sub print_time
-{
-	my($timestamp) = @_;
-	my($tm, $ms) = split /\:/, $timestamp;
-	my($sec, $min, $hour, $mday, $mon, $year, $wday, $yday) = gmtime($tm);
+#END MAIN PROGRAMM
 
-	if ($dates) {
-		$year += 1900;
-		$mon += 1;
-		return sprintf "%4d-%02d-%02d %02d:%02d:%02d.%09d",
-				$year, $mon, $mday, $hour, $min, $sec, $ms;
-	} else {
-		return sprintf "%02d:%02d:%02d.%09d",
-				$hour, $min, $sec, $ms;
-	}
-}
 
+#SUBS
 
-sub dbfprintf
-{
-	my(@argv) = @_;
-
-	if ($single_line) {
-		my($index);
-		while (($index = index($argv[0], "\t")) != -1) {
-			substr($argv[0], $index, 1) = "";
-		}
-		while (($index = index($argv[0], "\n")) != -1) {
-			substr($argv[0], $index, 1) = "; ";
-		}
-		while (($index = index($argv[0], ",")) != -1) {
-			substr($argv[0], $index, 1) = ";";
+#
+# Filters the scsi trace for the specified ports
+#
+# \param	Path to the traces
+#
+sub trace_scsi {
+	my(@scsi_paths) = @_;
+	
+	foreach my $scsi_path (@scsi_paths) {
+		open(DBF,$scsi_path . "/structured") or 
+		die("Cannot open DBF file " . $scsi_path . "/structured");
+		$scsi_path =~/(0\.0\.\w+)_\w+/;
+		my $adapter = $1;
+		my %scsi_hash;
+		while(<DBF>) {
+			if($_=~ /timestamp\s+([:\d]+)/) {
+				print_scsi($adapter,%scsi_hash);
+				%scsi_hash = ();
+				$scsi_hash{'timestamp'} = convert_time($1);
+			}
+			elsif ($_ =~ /(\w+)\s+(\w+)/) {
+				$scsi_hash{$1} = $2;;
+			}
 		}
+		print_scsi($adapter,%scsi_hash);
+		close(DBF);
 	}
+}
 
-	printf @argv;
+#
+# Print the scsi trace 
+#
+# \param	Adapter which is traced
+# \param	Data of the scsi trace
+#
+sub print_scsi {
+	my($adapter,%scsi_hash) = @_;
+	if(defined($scsi_hash{'timestamp'}) && defined($scsi_hash{'tag'}) && 
+		($scsi_hash{'tag'} eq 'rslt' || $scsi_hash{'tag'} eq 'abrt' ||
+		 $scsi_hash{'tag'} eq 'lrst' || $scsi_hash{'tag'} eq 'trst')) {
+		print "$adapter $scsi_hash{'timestamp'} " . 
+			"SCSI serial=$scsi_hash{'scsi_serial'}" . $endl .
+			"id=$scsi_hash{'scsi_id'} lun=$scsi_hash{'scsi_lun'} " .
+			"command=$scsi_hash{'scsi_cmnd'}" . $endl;
+		if($OPT_VERBOSE && $scsi_hash{'scsi_retries'}  ne hex 0) {
+			print "retry $scsi_hash{'scsi_retries'} ".
+				"from $scsi_hash{'scsi_allowed'}"; 
+		}
+	
+		if($scsi_hash{'fcp_rsp_validity'} ne '0x00') {
+			print "FCP_RSP validity=" .
+			      "$scsi_hash{'fcp_rsp_validity'} ";
+			if($OPT_VERBOSE) {
+				print "scsi_status=" .
+				      "$scsi_hash{'fcp_rsp_scsi_status'} " . 
+				      $endl . "residual=" .
+				      "$scsi_hash{'fcp_rsp_resid'} " .
+				      "code=0x$scsi_hash{'fcp_rsp_code'} ";
+			} 
+		}
+	
+		if($OPT_VERBOSE && $scsi_hash{'fcp_sns_info_len'} ne hex 0) {
+			print "FCP_SNS info=$scsi_hash{'fcp_sns_info'}";
+		}
+		print "\n";
+	}	 
 }
 
+#
+# Filters the hba trace for the specified ports
+#
+# \param	Path to the traces
+#
+sub trace_hba {
+	my(@hba_paths) = @_;
 
-sub dbfprintcr
-{
-	print "\n" if $single_line;
-}
-
-sub trace_hba
-{
-	foreach my $timestamp (sort keys %event_list) {
-		my($event) = $event_list{$timestamp};
-		my($tag) = &tag($event);
-
-		if (($debug_unsol) &&
-		    ($tag cmp $TAG_UNSOLICITED_STATUS) == 0) {
-			&dbfprintf("%s ", &print_label($timestamp));
-
-			my($subtag) = &subtag($event);
-			if (($subtag cmp $TAG_STATUS_READ) == 0) {
-				my($status_type, $status_subtype) = (
-					hex &grep($event, $STATUS_TYPE),
-					hex &grep($event, $STATUS_SUBTYPE)
-				);
-				my($queue_designator) =
-					&grep($event, $QUEUE_DESIGNATOR);
-
-				&dbfprintf("unsolicited status '%s'",
-						$unsolicited_status{$status_type});
-				&dbfprintf(" subtype=0x%08X",
-						$status_subtype)
-					unless !$verbose && $status_subtype == 0;
-
-				&dbfprintf("\n\tqueue designator='%s'",
-						$queue_designator)
-					unless !$verbose && &zarro($queue_designator);
-			} elsif (($subtag cmp $TAG_DISMISSED) == 0) {
-				&dbfprintf("status read request dismissed");
-			} elsif (($subtag cmp $TAG_FAILED) == 0) {
-				&dbfprintf("status read request failed");
-				&dbfprintf("\n\t%d status read requests " .
-						"failed on adapter",
-						hex &grep($event, $FAILED));
+	foreach my $hba_path (@hba_paths) {
+		open(DBF,$hba_path . "/structured") or 
+		die("Cannot open DBF file " . $hba_path . "/structured");
+		$hba_path =~/(0\.0\.\w+)_\w+/;
+		my $adapter = $1;
+		my %hba_hash;
+		while(<DBF>) {
+			if($_ =~ /timestamp\s+([:\d]+)/) {
+				print_hba($adapter, %hba_hash);
+				%hba_hash = ();
+				$hba_hash{'timestamp'} = convert_time($1);
 			}
-
-			my($payload) = &grep($event, $PAYLOAD);
-			&dbfprintf("\n\tpayload='%s'",
-					$payload)
-				unless !$verbose && &zarro($payload);
-
-			&dbfprintf("\n");
-			&dbfprintcr;
-			next;
-		} elsif (($debug_bad) && (
-		         (($tag cmp $TAG_PROT_STATUS_ERROR) == 0) ||
-		         (($tag cmp $TAG_FSF_STATUS_ERROR) == 0) ||
-		         (($tag cmp $TAG_STATUS_QUAL_AVAILABLE) == 0))) {
-			my($fsf_command) = hex &grep($event, $FSF_COMMAND);
-			my($prot_status, $prot_status_qual) = (
-				hex &grep($event, $PROT_STATUS),
-				    &grep($event, $PROT_STATUS_QUAL)
-			);
-			my($fsf_status, $fsf_status_qual) = (
-				hex &grep($event, $FSF_STATUS),
-				    &grep($event, $FSF_STATUS_QUAL)
-			);
-
-			&dbfprintf("%s response to '%s'\n",
-					&print_label($timestamp),
-					$fsf_command{$fsf_command});
-
-			&dbfprintf("\tprotocol status='%s' FSF status='%s'\n",
-					$protocol_status{$prot_status},
-					$fsf_status{$fsf_status})
-				unless !$verbose &&
-				       $prot_status == $FSF_PROT_GOOD &&
-				       $fsf_status == $FSF_GOOD;
-
-			&dbfprintf("\tprotocol status qualifier='%s'\n",
-					$prot_status_qual)
-				unless !$verbose && &zarro($prot_status_qual);
-
-			&dbfprintf("\tfsf status qualifier='%s'\n",
-					$fsf_status_qual)
-				unless !$verbose && &zarro($fsf_status_qual);
-
-			&dbfprintcr;
-			next;
-		} elsif (($tag cmp $TAG_FSF_REQ_RESPONSE) != 0) {
-			next;
-		}
-
-		my($fsf_req_id, $fsf_req_seqno, $fsf_command, $fsf_req_status) = (
-			hex &grep($event, $FSF_REQ_ID),
-			hex &grep($event, $FSF_REQ_SEQNO),
-			hex &grep($event, $FSF_COMMAND),
-			hex &grep($event, $FSF_REQUEST_STATUS)
-		);
-		my($prot_status, $prot_status_qual) = (
-			hex &grep($event, $PROT_STATUS),
-			    &grep($event, $PROT_STATUS_QUAL)
-		);
-		my($fsf_status, $fsf_status_qual) = (
-			hex &grep($event, $FSF_STATUS),
-			    &grep($event, $FSF_STATUS_QUAL)
-		);
-		my(@sbals) = (
-			hex &grep($event, $FIRST_SBAL),
-			hex &grep($event, $CURRENT_SBAL),
-			hex &grep($event, $LAST_SBAL)
-		);
-
-		&dbfprintf("%s %s\n",
-				&print_label($timestamp),
-				$fsf_command{$fsf_command});
-
-		&dbfprintf("\tprotocol status='%s' FSF status='%s'\n",
-				$protocol_status{$prot_status},
-				$fsf_status{$fsf_status})
-			unless !$verbose &&
-			       $prot_status == $FSF_PROT_GOOD &&
-			       $fsf_status == $FSF_GOOD;
-
-		&dbfprintf("\tprotocol status qualifier='%s'\n",
-				$prot_status_qual)
-			unless !$verbose && &zarro($prot_status_qual);
-
-		&dbfprintf("\tFSF status qualifier='%s'\n",
-				$fsf_status_qual)
-			unless !$verbose && &zarro($fsf_status_qual);
-
-		if ($verbose && $fsf_req_status != 0) {
-			&dbfprintf("\tFSF request status");
-			for (my($bit) = 1 << 31; $bit > 0; $bit >>= 1) {
-				my($value) = $fsf_req_status & $bit;
-				&dbfprintf(" '%s'", $fsf_req_status{$value})
-					unless $value == 0;
+			elsif ($_ =~ /^(\w+)\s+(\w+)$/) {
+				$hba_hash{$1} = $2;
+			}
+			elsif ($_ =~ /^(\w+)\s+(\w+\s\w+\s\w+\s\w+)$/) {
+				$hba_hash{$1} = $2;
+			}
+			elsif ($_ =~ /^(\w+)\s+(\w+\s\w+)$/) {
+				$hba_hash{$1} = $2;
 			}
-			&dbfprintf("\n");
-		}
-		&dbfprintf("\tSBAL=%d/%d/%d (first/current/last)\n",
-				$sbals[0], $sbals[1], $sbals[2])
-			unless !$verbose;
-
-		if ($fsf_command == $QTCB_ABORT_FCP_COMMAND) {
-			&dbfprintf("\tabort FSF request ID=%s seqno=%d\n",
-					&grep($event, $ABORT_FSF_REQ_ID),
-					hex &grep($event, $ABORT_FSF_REQ_SEQNO));
-		} elsif (($fsf_command == $QTCB_OPEN_PORT) ||
-		         ($fsf_command == $QTCB_CLOSE_PORT) ||
-		         ($fsf_command == $QTCB_CLOSE_PHYSICAL_PORT)) {
-			&dbfprintf("\tWWPN=%s D_ID=%s\n",
-					&grep($event, $WWPN),
-					&grep($event, $D_ID));
-			&dbfprintf("\tport handle=%s\n",
-					&grep($event, $PORT_HANDLE));
-		} elsif (($fsf_command == $QTCB_OPEN_LUN) ||
-		         ($fsf_command == $QTCB_CLOSE_LUN)) {
-			&dbfprintf("\tWWPN=%s LUN=%s\n",
-					&grep($event, $WWPN),
-					&grep($event, $FCP_LUN));
-			&dbfprintf("\tport handle=%s LUN handle=%s\n",
-					&grep($event, $PORT_HANDLE),
-					&grep($event, $LUN_HANDLE));
-		} elsif ($fsf_command == $QTCB_SEND_ELS) {
-			&dbfprintf("\tD_ID=%s LS code=%s\n",
-					&grep($event, $D_ID),
-					&grep($event, $PORT_HANDLE));
 		}
-
-		&dbfprintcr;
+		print_hba($adapter,%hba_hash);
+		close DBF;
 	}
 }
 
-sub trace_san
-{
-	foreach my $timestamp (sort keys %event_list) {
-		my($event) = $event_list{$timestamp};
-		my($tag) = &tag($event);
-
-		if (($debug_ct) && (
-		    (($tag cmp $TAG_CT_REQUEST) == 0) ||
-		    (($tag cmp $TAG_CT_RESPONSE) == 0))) {
-			my($s_id, $d_id) = (
-				&grep($event, $S_ID),
-				&grep($event, $D_ID)
-			);
-
-			&dbfprintf("%s %s -> %s CT %s\n",
-					&print_label($timestamp),
-					$s_id, $d_id,
-					($tag cmp $TAG_CT_REQUEST) == 0 ?
-					"request" : "response");
-
-			&dbfprintf("\tFSF request=0x%x, seqno=%d\n",
-					hex &grep($event, $FSF_REQ_ID),
-					hex &grep($event, $FSF_REQ_SEQNO))
-						if $verbose;
-			&dbfprintcr;
-		} elsif (($debug_els) && (
-		         (($tag cmp $TAG_ELS_REQUEST) == 0) ||
-		         (($tag cmp $TAG_ELS_RESPONSE) == 0))) {
-			my($s_id, $d_id, $ls_code) = (
-				    &grep($event, $S_ID),
-				    &grep($event, $D_ID),
-				hex &grep($event, $LS_CODE)
-			);
-
-			&dbfprintf("%s %s -> %s %s %s\n",
-					&print_label($timestamp),
-					$s_id, $d_id, $els{$ls_code},
-					($tag cmp $TAG_ELS_REQUEST) == 0 ?
-					"request" : "response");
-			&dbfprintcr;
-		} elsif (($debug_els) && (
-		         ($tag cmp $TAG_INCOMING_ELS) == 0)) {
-			my($s_id, $d_id, $ls_code) = (
-				    &grep($event, $S_ID),
-				    &grep($event, $D_ID),
-				hex &grep($event, $LS_CODE)
-			);
-
-			&dbfprintf("%s %s -> %s incoming %s\n",
-					&print_label($timestamp),
-					$s_id, $d_id, $els{$ls_code});
-			&dbfprintcr;
+#
+# Print the hba trace 
+#
+# \param	Adapter which is traced
+# \param	Data of the hba trace
+#
+sub print_hba {
+	my($adapter,%hba_hash) = @_;	
+	if(defined($hba_hash{'timestamp'})) { 
+		#Unsolicited status
+		if(defined($hba_hash{'tag'}) && $hba_hash{'tag'} eq "stat") {
+			if(defined($hba_hash{'tag2'}) && 
+			$hba_hash{'tag2'} eq "read") { 
+			    	if(defined($hba_hash{'timestamp'}) && 
+				 defined($hba_hash{'status_type'}) && 
+				 defined($hba_hash{'status_subtype'}) && 
+				 defined($hba_hash{'queue_designator'})) {
+					print "$adapter $hba_hash{
+					'timestamp'} " .
+					"unsolicited status" .
+					" '$unsolicited_status{
+						$hba_hash{'status_type'}}'"
+					. $endl .
+					"subtype= $hba_hash{'status_subtype'}"
+					. $endl .
+					"queue designator= $hba_hash{
+					'queue_designator'}" . $endl ;
+			  	  }
+			}
+			elsif(defined($hba_hash{'tag2'}) && 
+				$hba_hash{'tag2'} eq "dism") {
+				print "status read request dissmissed";
+			}
+			elsif(defined($hba_hash{'tag2'}) && 
+				$hba_hash{'tag2'} eq "fail") {
+				print "status read request failed";
+			}
+		}		
+		elsif(defined($hba_hash{'tag'}) && $hba_hash{'tag'} eq "resp") {
+			if(defined($hba_hash{'tag2'}) && 
+			($hba_hash{'tag2'} eq "perr" || 
+			 $hba_hash{'tag2'} eq "ferr" || 
+			 $hba_hash{'tag2'} eq "open" || 
+			 $hba_hash{'tag2'} eq "qtcb")) {
+				print "$adapter $hba_hash{'timestamp'} " .
+				"response to '$fsf_command{
+					$hba_hash{'fsf_command'}}'" . $endl;
+				print "protocol status='$protocol_status{
+					$hba_hash{'fsf_prot_status'}}'" . 
+					"FSF status='$fsf_status{
+					$hba_hash{'fsf_status'}}'" . $endl ; 
+			}  
+		}	
+		else {
+			next;
 		}
+		
+		if($OPT_VERBOSE) {
+			print "protocol status qualifier=" .
+				"'$hba_hash{'fsf_prot_status_qual'}'" . $endl .
+				"FSF status qualifier=" .
+				"'$hba_hash{'fsf_status_qual'}'" . $endl .
+				"FSF request status " .
+				"'$hba_hash{'fsf_req_status'}'" . $endl .
+				"SBAL=$hba_hash{'sbal_first'}/$hba_hash{
+				'sbal_last'}/$hba_hash{'sbal_response'} " .
+				"(fist/last/response)" . $endl; 
+		}
+
+		if($hba_hash{'fsf_command'} eq '0x00000002') {
+			print "Abort FSF request " .
+				"ID=$hba_hash{'abort_fsf_reqid'} " .
+				"seqno=$hba_hash{'abort_fsf_seqno'}";
+		}
+		elsif($hba_hash{'fsf_command'} eq '0x00000005' || 
+			$hba_hash{'fsf_command'} eq '0x00000008' ||
+		$hba_hash{'fsf_command'} eq '0x00000009') {
+			print "WWPN=$hba_hash{'wwpn'} D_ID=$hba_hash{'d_id'} ";
+			print "port handle=$hba_hash{'port_handle'}";
+		}
+		elsif($hba_hash{'fsf_command'} eq '0x00000006' || 
+			$hba_hash{'fsf_command'} eq '0x00000007') {
+			print "WWPN=$hba_hash{'wwpn'} " .
+				"LUN=$hba_hash{'fcp_lun'}" . $endl;
+			print "port handle=$hba_hash{'port_handle'}" .
+				" LUN handle=$hba_hash{'lun_handle'}"; 
+		}
+		elsif($hba_hash{'fsf_command'} eq '0x0000000b' ) {
+			print "D_ID=$hba_hash{'d_id'} LS " .
+				"code=$hba_hash{'port_handle'}";
+		}
+		print"\n";
 	}
 }
 
-sub trace_scsi
-{
-	foreach my $scsi_timestamp (sort keys %event_list) {
-		my($scsi_event, $fsf_event) =
-			($event_list{$scsi_timestamp}, "");
-
-		my($tag) = &grep($scsi_event, $TAG);
-		next unless ($tag cmp $TAG_SCSI_COMPLETION) == 0 ||
-		            ($tag cmp $TAG_SCSI_ABORT) == 0 ||
-		            ($tag cmp $TAG_SCSI_TARGET_RESET) == 0 ||
-		            ($tag cmp $TAG_SCSI_RESET) == 0;
-
-		my($fsf_req_id, $fsf_req_seqno) = (
-			hex &grep($scsi_event, $FSF_REQ_ID),
-			hex &grep($scsi_event, $FSF_REQ_SEQNO)
-		);
-
-		foreach my $fsf_timestamp (sort keys %event_list) {
-			my($sub_event) = $event_list{$fsf_timestamp};
-			my($sub_fsf_req_id, $sub_fsf_req_seqno) = (
-				hex &grep($sub_event, $FSF_REQ_ID),
-				hex &grep($sub_event, $FSF_REQ_SEQNO)
-			);
-			if (($sub_fsf_req_id == $fsf_req_id) &&
-		            ($sub_fsf_req_seqno == $fsf_req_seqno)) {
-				$fsf_event = $sub_event;
-				last;
+#
+# Filters the rec trace for the specified ports
+#
+# \param	Path to the traces
+#
+sub trace_rec {
+	my(@rec_paths) = @_;
+
+	foreach my $rec_path ( @rec_paths ) {
+		open(DBF,$rec_path . "/structured") or 
+		die("Cannot open DBF file " . $rec_path . "/structured");
+		$rec_path =~/(0\.0\.\w+)_\w+/;  
+		my $adapter = $1;
+		my %rec_hash;
+		while(<DBF>) {
+			if($_ =~ /timestamp\s+([:\d]+)/) {
+				print_rec($adapter,%rec_hash);
+				%rec_hash = ();
+				$rec_hash{'timestamp'} = convert_time($1);
+				print "\n";
+			}
+			elsif ($_ =~ /(\w+)\s+(\w+)/) {
+				$rec_hash{$1} = $2;
 			}
 		}
+		print_rec($adapter,%rec_hash);
+		print "\n";
+		close DBF;  
+	}
+}
 
-		my($scsi_command, $scsi_serial, $scsi_id, $scsi_lun) = (
-			hex &grep($scsi_event, $SCSI_COMMAND),
-			hex &grep($scsi_event, $SCSI_SERIAL),
-			hex &grep($scsi_event, $SCSI_ID),
-			hex &grep($scsi_event, $SCSI_LUN)
-		);
-		my($scsi_retries, $scsi_allowed) = (
-			hex &grep($scsi_event, $SCSI_RETRIES),
-			hex &grep($scsi_event, $SCSI_ALLOWED)
-		);
-		my($rsp_validity, $rsp_scsi_status, $rsp_reidual, $rsp_code) = (
-			hex &grep($scsi_event, $FCP_RSP_VALIDITY),
-			hex &grep($scsi_event, $FCP_RSP_SCSI_STATUS),
-			hex &grep($scsi_event, $FCP_RSP_RESIDUAL),
-			hex &grep($scsi_event, $FCP_RSP_CODE)
-		);
-		my($sns_info, $sns_info_len) = (
-			hex &grep($scsi_event, $FCP_SNS_INFO),
-			hex &grep($scsi_event, $FCP_SNS_INFO_LEN)
-		);
-		my($fsf_command, $fsf_req_status) = (
-			hex &grep($fsf_event, $FSF_COMMAND),
-			hex &grep($fsf_event, $FSF_REQUEST_STATUS)
-		);
-		my($prot_status, $prot_status_qual) = (
-			hex &grep($fsf_event, $PROT_STATUS),
-			    &grep($fsf_event, $PROT_STATUS_QUAL)
-		);
-		my($fsf_status, $fsf_status_qual) = (
-			hex &grep($fsf_event, $FSF_STATUS),
-			    &grep($fsf_event, $FSF_STATUS_QUAL)
-		);
-		my(@sbals) = (
-			hex &grep($fsf_event, $FIRST_SBAL),
-			hex &grep($fsf_event, $CURRENT_SBAL),
-			hex &grep($fsf_event, $LAST_SBAL)
-		);
-
-		&dbfprintf("%s SCSI serial=%d id=%d lun=%d command=0x%lx",
-				&print_label($scsi_timestamp),
-				$scsi_serial,
-				$scsi_id,
-				$scsi_lun,
-				$scsi_command);
-		&dbfprintf(" retry %d from %d",
-				$scsi_retries,
-				$scsi_allowed)
-			unless !$verbose && $scsi_retries == 0;
-		&dbfprintf("\n");
-
-
-		if ($rsp_validity != 0) {
-			&dbfprintf("\tFCP_RSP validity=0x%02X",
-					$rsp_validity);
-			&dbfprintf(" scsi_status=0x%02X",
-					$rsp_scsi_status)
-				unless !$verbose && $rsp_scsi_status == 0;
-			&dbfprintf(" residual=%d",
-					$rsp_reidual)
-				unless !$verbose && $rsp_reidual == 0;
-			&dbfprintf(" code=0x%08X",
-					$rsp_code)
-				unless !$verbose && $rsp_code == 0;
-			&dbfprintf("\n");
-		}
+#
+# Prints the rec traces 
+#
+# \param	Adapter which is traced
+# \param	Data of the rec trace
+#
+sub print_rec {
+	my($adapter,%rec_hash) = @_;
+	if(defined($rec_hash{'timestamp'}) && defined($rec_hash{'tag'}) && 
+		defined($rec_hash{'hint'}) && defined($rec_hash{'wwpn'}) &&
+		defined($rec_hash{'fcp_lun'})) {
+		print "$adapter $rec_hash{'timestamp'}\ttag=$rec_hash{'tag'} " .
+		  	"hint=$rec_hash{'hint'}" . $endl .
+			"WWPN='$rec_hash{'wwpn'}' lun='$rec_hash{'fcp_lun'}'";
+	} 
+}
 
-		&dbfprintf("\tFCP_SNS info=%s\n",
-				$sns_info)
-			unless !$verbose && $sns_info_len == 0;
-
-		&dbfprintf("\tprotocol status='%s' FSF status='%s'\n",
-				$protocol_status{$prot_status},
-				$fsf_status{$fsf_status})
-			unless !$verbose &&
-			       $prot_status == $FSF_PROT_GOOD &&
-			       $fsf_status == $FSF_GOOD;
-
-		&dbfprintf("\tprotocol status qualifier='%s'\n",
-				$prot_status_qual)
-			unless !$verbose && &zarro($prot_status_qual);
-
-		&dbfprintf("\tfsf status qualifier='%s'\n",
-				$fsf_status_qual)
-			unless !$verbose && &zarro($fsf_status_qual);
-
-		if ($verbose && $fsf_req_status != 0) {
-			&dbfprintf("\tfsf request status");
-			for (my($bit) = 1 << 31; $bit > 0; $bit >>= 1) {
-				my($value) = $fsf_req_status & $bit;
-				&dbfprintf(" '%s'", $fsf_req_status{$value})
-					unless $value == 0;
+# 
+# Filters the san trace for the specified ports
+#
+# \param	Path to the traces
+#
+sub trace_san {
+	my(@san_paths) = @_;
+		
+	foreach my $san_path (@san_paths) {
+		open(DBF,$san_path . "/structured") or 
+		die("Cannnot open DBF file " . $san_path . "/structured");
+		$san_path =~ /(0\.0\.\w+)_\w+/;
+		my $adapter = $1;
+		my %san_hash;
+		while(<DBF>) {
+			if($_ =~ /timestamp\s+([:\d]+)/) {
+				#Every new block starts with a timestamp and 
+				#since we cannot be sure that a block ends with 
+				#a blank line we check for the next timestamp
+				print_san($adapter,%san_hash);
+				%san_hash = ();
+				$san_hash{'timestamp'} = convert_time($1);
+			}
+			elsif ($_ =~ /(\w+)\s+(\w+)/) {
+				$san_hash{$1} = $2;
 			}
-			&dbfprintf("\n");
 		}
+		print_san($adapter,%san_hash);
+		print"\n";
+		close DBF;
+	}
+	return;
+}
 
-		&dbfprintf("\tSBAL=%d/%d/%d (first/current/last)\n",
-				$sbals[0], $sbals[1], $sbals[2])
-					if $verbose;
-
-		if ($fsf_command == $QTCB_ABORT_FCP_COMMAND) {
-			&dbfprintf("\tabort fsf request id=%s seqno=%d\n",
-					&grep($event, $ABORT_FSF_REQ_ID),
-					hex &grep($event, $ABORT_FSF_REQ_SEQNO));
-		}
+#
+# Prints the san traces 
+#
+# \param	Adapter which is traced
+# \param	Data of the san trace
+#
+sub print_san {
+	my($adapter,%san_hash) = @_;
 
-		&dbfprintcr;
+	if(defined($san_hash{'timestamp'}) && defined($san_hash{'s_id'}) && 
+		defined($san_hash{'d_id'}) && defined($san_hash{'tag'})) {
+		my $tag;
+		if($san_hash{'tag'} eq "octc") { 
+			$tag = "CT request";
+		}
+		elsif($san_hash{'tag'} eq "rctc") {
+			$tag = "CT response";
+		}
+		elsif($san_hash{'tag'} eq "oels") {
+			$tag = "ELS request";
+		}
+		elsif($san_hash{'tag'} eq "rels") {
+			$tag = "ELS respsone";
+		}
+		elsif($san_hash{'tag'} eq "iels") {
+			$tag = "ELS incoming";
+		} 	
+		print "$adapter $san_hash{'timestamp'}\t$san_hash{'s_id'} " .
+			" -> $san_hash{'d_id'} $tag \n";
 	}
 }
 
-sub tag
-{
-	my($event) = @_;
-	return &grep($event, $TAG);
-}
-
-sub subtag
-{
-	my($event) = @_;
-	return &grep($event, $SUBTAG);
-}
-
-sub is
-{
-	my($event, $field_name) = @_;
-	my(@field_list) = split /\;/, $event;
-	my($label, $value);
-
-	foreach my $field (@field_list) {
-		($label, $value) = split /\=/, $field;
-		return 1 if ($label cmp $field_name) == 0;
-	}
-	return 0;
+#
+# Converts the Unix time to localtime an returns it 
+# depending on the --date option.
+#
+# \param	UNIX Timestamp to convert
+# \return 	Formated Localtime
+#
+sub convert_time {
+	my($timestamp) = @_;
+	
+	my @conv_time = split(/:/,$timestamp);
+	my @local_t = localtime($conv_time[0]);
+	if($OPT_DATE eq "on") {
+		return (sprintf "%04d-%02d-%02d %02d:%02d:%02d.%d", 
+			($local_t[5]+1900) ,$local_t[4],$local_t[3],$local_t[2],
+			$local_t[1],$local_t[0], $conv_time[1]);
+	}
+	else {
+		return (sprintf "%02d:%02d:%02d.%d",$local_t[2],
+			$local_t[1],$local_t[0], $conv_time[1]);
+	} 
 }
 
-sub grep
-{
-	my($event, $field_name) = @_;
-	my(@field_list) = split /\;/, $event;
-	my($label, $value);
-
-	foreach my $field (@field_list) {
-		($label, $value) = split /\=/, $field;
-		last if ($label cmp $field_name) == 0;
+#
+# Filters the path to trace 
+#
+#\param		The filter for the paths
+#\param		Path to the traces
+#\return	The filtered pathes
+#
+sub filter_paths {
+	my($filter,@paths) = @_;
+	
+	my @filtered_paths;
+	
+	foreach my $path (@paths) {
+		if($path =~ /_$filter$/) {
+			push(@filtered_paths,$path);
+		}
+	}
+	unless(@filtered_paths) {
+		print "No traces for '$filter' found\n";
+		exit;
 	}
-	return (($label cmp $field_name) == 0) ? $value : $UNKNOWN;
+	return \@filtered_paths;
 }
 
-sub zarro
-{
-	my($field) = @_;
+#
+# Prints the version
+#
+sub print_version {
 
-	for (my $index = 0; $index < length($field); $index++) {
-		my($char) = substr($field, $index, 1);
-		return $FALSE if (($char != '0') && ($char != ' '));
-	}
-	return $TRUE;
+	my ($s390tools_version) = '%S390_TOOLS_VERSION%';
+	printf "zfcpdbf: version %s\n", $s390tools_version;
+	printf "Copyright IBM Corp. 2005,2009\n";
+	exit;
 }
 
-sub kernel_version
-{
-	my($release) = @_;
-	my($version, $patchlevel, $sublevel) = split /\./, $release;
-	return (int $version << 16) + (int $patchlevel << 8) + (int $sublevel);
+#
+# Prints the usage
+#
+sub print_usage {
+print 
+"
+Usage: zfcpdbf [COMMAND] [OPTIONS]
+
+Sort debug data of all active or specified FCP adapter(s).
+	-h, --help                display this help and exit
+ 	-v, --version             display version information and exit
+commands:
+	hba                     trace all FSF requests
+	san                     trace SAN activity (default)
+  	scsi                    trace SCSI- and corresponding FCP-commands
+	rec			  trace REC records
+	options:
+	  -d, --device=<device>   FCP adapter device number
+	  -p, --path=<path>       specifiy path to DBF files
+	  -D, --dates={off|on}    show date as well as time 
+	  -s, --singleline        output in one line per event
+	  -V, --verbose           verbose output
+	
+";
+	exit;
 }
-
-&init;
-&load;
-&main;
-&done;
